package cn.dankal.test.common;

import org.apache.kafka.common.TopicPartition;

import java.time.format.DateTimeFormatter;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-01-25
 */
public interface Const {

    /**
     * format pattern: yyyy-MM-dd HH:mm:ss.SSS
     */
    DateTimeFormatter FULL_DATE_TIME_FORMATTER = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss.SSS");

    /**
     * TODO 由于只是测试 故就不做执行保存数据操作,此处使用 本地 Map 存储分区与对应偏移量信息
     * <pre>
     *      key: TopicPartition 分区信息
     *      value: Long 分区偏移量信
     * </pre>
     */
    ConcurrentHashMap<TopicPartition, Long> PARTITION_OFFSET_INFO_MAP = new ConcurrentHashMap<>();


    /**
     * Kafka const
     */
    interface Kafka {
        /**
         * kafka topic
         */
        interface Topic {
            /**
             * kafka topic: dankal-test-hello-kafka
             */
            String HELLO_TOPIC = "dankal-test-hello-kafka";
        }

        /**
         * kafka consumer group id
         */
        interface ConsumerGroupId {
            /**
             * hello-consumer-group-id
             */
            String HELLO_CONSUMER_GROUP_ID = "hello-consumer-group-id";

            /**
             * test-group-a
             */
            String TEST_GROUP_A = "test-group-a";
            /**
             * test-group-b
             */
            String TEST_GROUP_B = "test-group-b";
            /**
             * test-group-c
             */
            String TEST_GROUP_C = "test-group-c";

            /**
             * test-kafka-rebalance
             */
            String TEST_KAFKA_REBALANCE = "test-kafka-rebalance";
        }
    }

}
