package cn.dankal.test.boot.listener;

import cn.dankal.test.boot.common.Common;
import cn.dankal.test.boot.common.Const;
import cn.dankal.test.boot.entity.DankalSimpleMessage;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.support.Acknowledgment;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;

/**
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-01-21
 */
@Slf4j
@Component
@ConditionalOnMissingBean(name = {"testErrorHandler"})
public class KafkaDankalMessageListener {


    @KafkaListener(
            topics = {Const.Kafka.Topic.TOPIC_HELLO_SPRING_KAFKA},
            groupId = Const.Kafka.ConsumerGroupId.GROUP_ID_HELLO_SPRING_KAFKA_CONSUMER
    )
    public void dankalMessageListener(DankalSimpleMessage dankalSimpleMessage,
                                      Acknowledgment acknowledgment) {
        if (log.isInfoEnabled()) {
            log.info("{} 执行线程: {} 消费消息 ==> 主题: {}",
                    Const.FULL_DATE_TIME_FORMATTER.format(LocalDateTime.now()),
                    Common.getSpringKafkaConsumerName(Thread.currentThread().getName()),
                    dankalSimpleMessage);
        }
        acknowledgment.acknowledge();
    }
}
